## llhttp 9.3.3~really9.3.0+~cs12.11.8

=== examples/http/Makefile ===
CC ?= clang

all: http

http: main.c http_parser.bc
	$(CC) -g3 -flto -Os -fvisibility=hidden -Wall -I. http_parser.c main.c -o $@

http_parser.bc: index.ts
	npx ts-node $<

.PHONY = all

## llhttp 9.2.1+~cs12.9.9

=== debian/changelog ===
llhttp (9.2.1+~cs12.9.9-1) unstable; urgency=medium

  * Initial release. (Closes: #1095292)

 -- Jérémy Lal <kapouer@melix.org>  Tue, 18 Feb 2025 17:45:16 +0100

=== debian/control ===
Source: llhttp
Section: javascript
Priority: optional
Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
Uploaders: Jérémy Lal <kapouer@melix.org>
Build-Depends: debhelper-compat (= 13)
 , dh-nodejs
 , binaryen
 , clang (>= 1:16)
 , cmake
 , libclang-rt-dev-wasm32
 , lld (>= 1:16)
 , node-debug
 , node-markdown-it
 , node-semver
 , node-typescript
 , ts-node
 , wasi-libc
Standards-Version: 4.7.0
Homepage: https://llhttp.org/
Vcs-Git: https://salsa.debian.org/js-team/llhttp.git
Vcs-Browser: https://salsa.debian.org/js-team/llhttp
Rules-Requires-Root: no

Package: libllhttp-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}
 , libllhttp9.2 (= ${binary:Version})
Breaks: libllhttp-dev (<< 7.3.0+dfsg2~)
Replaces: libllhttp-dev (<< 7.3.0+dfsg2~)
Description: HTTP messages parser library (devel)
 llhttp generates a C HTTP messages parser from typescript
 definitions, making it easier to maintain.
 .
 This package contains the static library and C headers.

Package: libllhttp9.2
Section: libs
Architecture: any
Depends: ${misc:Depends}
 , ${shlibs:Depends}
Breaks: libllhttp9.1 (<< 6), libllhttp9.2 (<< 7.3.0+dfsg2~)
Replaces: libllhttp9.1, libllhttp9.2 (<< 7.3.0+dfsg2~)
Description: HTTP messages parser library
 llhttp generates a C HTTP messages parser from typescript
 definitions, making it easier to maintain.

Package: node-llhttp
Architecture: all
Depends: ${misc:Depends}
 , node-debug
 , node-semver
Breaks: node-llhttp (<< 7.3.0+dfsg2~)
Replaces: node-llhttp (<< 7.3.0+dfsg2~)
Multi-Arch: foreign
Description: HTTP messages parser library - Node.js module
 llhttp generates a C HTTP messages parser from typescript
 definitions, making it easier to maintain.
 .
 This package contains the Node.js module and wasm library.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

LLHTTPVERSION = $(shell pkgjs-pjson . version)
export RELEASE = $(LLHTTPVERSION)
LLHTTPMAJORVERSION = $(shell pkgjs-pjson . version|perl -pe 's/\..*//')
export SONAME = libllhttp.so.$(LLHTTPVERSION)
export SONAMEALIAS = libllhttp.so.$(LLHTTPMAJORVERSION)
LIBLLHTTPVERSION = $(LLHTTPVERSION)~$(DEB_VERSION)

export PREFIX = debian/tmp/usr
export LIBDIR = debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
export INCLUDEDIR = debian/tmp/usr/include

WASM_CFLAGS = --sysroot=/usr -target wasm32-unknown-wasi -fno-exceptions -fvisibility=hidden -mexec-model=reactor

WASM_LDFLAGS = -Wl,-error-limit=0 \
-Wl,-O3  \
-Wl,--lto-O3  \
-Wl,--strip-all  \
-Wl,--allow-undefined  \
-Wl,--export-dynamic  \
-Wl,--export-table  \
-Wl,--export=malloc  \
-Wl,--export=free  \
-Wl,--no-entry

WASM_OUT = build
WASM_SRC = $(WASM_OUT)/c/*.c  src/native/*.c
WASM_INC = -I$(WASM_OUT)
WASM_OPT_FLAGS = -O4 --converge --strip-debug --strip-dwarf --strip-producers --enable-bulk-memory

%:
	dh $@

execute_before_dh_auto_clean:
	dh_auto_clean --buildsystem=nodejs

execute_before_dh_auto_configure:
	dh_auto_configure --buildsystem=nodejs

execute_before_dh_auto_build:
	dh_auto_build --buildsystem=nodejs
	RELEASE=$(LLHTTPVERSION) make release all

	clang $(WASM_CFLAGS) $(WASM_LDFLAGS) $(WASM_SRC) $(WASM_INC) -o $(WASM_OUT)/llhttp.wasm
	wasm-opt $(WASM_OPT_FLAGS) -o $(WASM_OUT)/llhttp.wasm $(WASM_OUT)/llhttp.wasm

	clang $(WASM_CFLAGS) -msimd128 $(WASM_LDFLAGS) $(WASM_SRC) $(WASM_INC) -o $(WASM_OUT)/llhttp_simd.wasm
	wasm-opt $(WASM_OPT_FLAGS) --enable-simd -o $(WASM_OUT)/llhttp.wasm $(WASM_OUT)/llhttp.wasm
	
	dh_auto_configure --buildsystem=cmake -Drelease -- -DCMAKE_BUILD_TYPE=Release
	dh_auto_build --buildsystem=cmake -Drelease

execute_before_dh_auto_install:
	make install
	dh_auto_install --buildsystem=nodejs

execute_before_dh_auto_test:
	dh_auto_test --buildsystem=nodejs

=== debian/watch ===
version=4
opts=\
dversionmangle=auto,\
filenamemangle=s/.*?(@ANY_VERSION@@ARCHIVE_EXT@)/node-llhttp-$1/ \
 https://github.com/nodejs/llhttp/tags .*?@ANY_VERSION@@ARCHIVE_EXT@ group

opts=\
component=llparse,\
dversionmangle=auto,\
filenamemangle=s/.*?(@ANY_VERSION@@ARCHIVE_EXT@)/node-llparse-$1/ \
 https://github.com/nodejs/llparse/tags .*?@ANY_VERSION@@ARCHIVE_EXT@ checksum

opts=\
component=llparse-frontend,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-llparse-frontend-$1/ \
 https://github.com/nodejs/llparse-frontend/tags .*/archive.*/v?([\d\.]+).tar.gz checksum

opts=\
component=llparse-builder,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-llparse-builder-$1/ \
 https://github.com/nodejs/llparse-builder/tags .*/archive.*/v?([\d\.]+).tar.gz checksum

opts=\
component=binary-search,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-binary-search-$1/ \
 https://github.com/darkskyapp/binary-search/tags .*/archive.*/v?([\d\.]+).tar.gz checksum

## llhttp 9.3.0+~cs12.11.8

=== debian/changelog ===
llhttp (9.3.0+~cs12.11.8-3) unstable; urgency=medium

  * Binary upload to break the loop:
    nodejs > node-undici > node-llhttp > nodejs

 -- Jérémy Lal <kapouer@melix.org>  Mon, 01 Sep 2025 02:31:26 +0200

llhttp (9.3.0+~cs12.11.8-2) unstable; urgency=medium

  * Upload to unstable 

 -- Jérémy Lal <kapouer@melix.org>  Fri, 29 Aug 2025 16:19:24 +0200

llhttp (9.3.0+~cs12.11.8-1) experimental; urgency=medium

  * New upstream version 9.3.0+~cs12.11.8
  * Add patches to fix CMakeLists installed by libllhttp-source
  * Builds libllhttp-source and node-llhttp including wasm blobs
  * Tighten B-D w.r.t. nocheck profile
  * Use dh-sequence-nodejs

 -- Jérémy Lal <kapouer@melix.org>  Fri, 29 Aug 2025 16:19:03 +0200

=== debian/control ===
Source: llhttp
Section: javascript
Priority: optional
Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
Uploaders: Jérémy Lal <kapouer@melix.org>
Build-Depends: debhelper-compat (= 13)
 , dh-sequence-nodejs
 , dh-nodejs
 , binaryen
 , clang
 , libclang-rt-dev-wasm32
 , lld (>= 1:16)
 , node-debug
 , node-markdown-it (>= 22.2.3+dfsg+~12.2.3-2~) <!nocheck>
 , node-semver
 , node-typescript
 , ts-node
 , wasi-libc
Standards-Version: 4.7.2
Homepage: https://llhttp.org/
Vcs-Git: https://salsa.debian.org/js-team/llhttp.git
Vcs-Browser: https://salsa.debian.org/js-team/llhttp
Rules-Requires-Root: no

Package: libllhttp-source
Section: libs
Architecture: all
Depends: ${misc:Depends}
Description: HTTP messages parser library - source
 llhttp generates a C HTTP messages parser from typescript
 definitions, making it easier to maintain.
 .
 This package contains the generated sources.

Package: node-llhttp
Architecture: all
Depends: ${misc:Depends}
 , node-debug
 , node-semver
Multi-Arch: foreign
Description: HTTP messages parser library - Node.js module
 llhttp generates a C HTTP messages parser from typescript
 definitions, making it easier to maintain.
 .
 This package contains the Node.js module that exposes
 constants and exports the WebAssembly blobs.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/pkg-info.mk
sonameVersion = $(shell echo $(DEB_VERSION_UPSTREAM) | cut -d '+' -f 1 | cut -d '.' -f -3)

%:
	dh $@

execute_after_dh_auto_build:
	RELEASE=$(sonameVersion) make release
	WASM_OPT=/usr/bin/wasm-opt WASM_CC=/usr/bin/clang WASM_CFLAGS="--sysroot=/usr -target wasm32-unknown-wasi" node debian/wasm.js

=== debian/watch ===
--- 
+++ 
@@ -6,9 +6,10 @@
 
 opts=\
 component=llparse,\
+ctype=nodejs,\
 dversionmangle=auto,\
-filenamemangle=s/.*?(@ANY_VERSION@@ARCHIVE_EXT@)/node-llparse-$1/ \
- https://github.com/nodejs/llparse/tags .*?@ANY_VERSION@@ARCHIVE_EXT@ checksum
+filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-llparse-$1/ \
+ https://github.com/nodejs/llparse/tags .*/archive.*/v?([\d\.]+).tar.gz checksum
 
 opts=\
 component=llparse-frontend,\

## llhttp 9.3.3~really9.3.0%2B~cs12.11.8

=== debian/watch ===
Version: 5

Template: Github
Dversionmangle: s/9.3.3~really(\d+\.\d+\.\d+)/$1/
Uversionmangle: s/(\d+\.\d+\.\d+)/9.3.3~really$1/
Owner: nodejs
Project: llhttp
Version-Schema: group

Component: llparse
Template: Github
Ctype: nodejs
Dversionmangle: auto
Owner: nodejs
Project: llparse
Version-Schema: checksum

Component: llparse-frontend
Template: Github
Ctype: nodejs
Dversionmangle: auto
Owner: nodejs
Project: llparse-frontend
Version-Schema: checksum

Component: llparse-builder
Template: Github
Ctype: nodejs
Dversionmangle: auto
Owner: nodejs
Project: llparse-builder
Version-Schema: checksum

Component: binary-search
Template: Github
Ctype: nodejs
Dversionmangle: auto
Owner: darkskyapp
Project: binary-search
Version-Schema: checksum

## llhttp 9.3.3~really9.3.0+~cs12.11.8

=== debian/changelog ===
llhttp (9.3.3~really9.3.0+~cs12.11.8-3) unstable; urgency=medium

  * Breaks node-undici << 7.15.0+dfsg+~cs3.2.0-1

 -- Jérémy Lal <kapouer@melix.org>  Wed, 03 Sep 2025 18:42:46 +0200

llhttp (9.3.3~really9.3.0+~cs12.11.8-2) unstable; urgency=medium

  * Install node components

 -- Jérémy Lal <kapouer@melix.org>  Wed, 03 Sep 2025 18:42:22 +0200

llhttp (9.3.3~really9.3.0+~cs12.11.8-1) unstable; urgency=medium

  * Artificially bump version to be higher than the 9.3.2
    version of the native source package libllhttp.
  * Update watch version to 5
  * Use Build-Depends-Indep and targets to build all packages
    without the need for libllhttp source package.
  * Add README.source about bootstrap.
  * M-A foreign for libllhttp-source.
  * Tighten dependency on libllhttp-source 9.3.x.

 -- Jérémy Lal <kapouer@melix.org>  Tue, 02 Sep 2025 15:15:46 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,13 @@
 Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
 Uploaders: Jérémy Lal <kapouer@melix.org>
 Build-Depends: debhelper-compat (= 13)
- , dh-sequence-nodejs
+Build-Depends-Arch:
+ , dh-cmake-compat (=1)
+ , dh-cmake
+ , cmake
+ , libllhttp-source (>= 9.3~),
+ , libllhttp-source (<< 9.4~)
+Build-Depends-Indep:
  , dh-nodejs
  , binaryen
  , clang
@@ -20,11 +26,11 @@
 Homepage: https://llhttp.org/
 Vcs-Git: https://salsa.debian.org/js-team/llhttp.git
 Vcs-Browser: https://salsa.debian.org/js-team/llhttp
-Rules-Requires-Root: no
 
 Package: libllhttp-source
 Section: libs
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Description: HTTP messages parser library - source
  llhttp generates a C HTTP messages parser from typescript
@@ -37,6 +43,8 @@
 Depends: ${misc:Depends}
  , node-debug
  , node-semver
+Provides: ${nodejs:Provides}
+Breaks: node-undici (<< 7.15.0+dfsg+~cs3.2.0-1)
 Multi-Arch: foreign
 Description: HTTP messages parser library - Node.js module
  llhttp generates a C HTTP messages parser from typescript
@@ -44,3 +52,27 @@
  .
  This package contains the Node.js module that exposes
  constants and exports the WebAssembly blobs.
+
+Package: libllhttp-dev
+Section: libdevel
+Architecture: any
+Depends: ${misc:Depends}
+ , libllhttp9.3 (= ${binary:Version})
+Description: HTTP messages parser library dev files
+ A C HTTP messages parser generated from typescript
+ definitions, making it easier to maintain.
+ .
+ This package contains the development files.
+
+Package: libllhttp9.3
+Section: libs
+Architecture: any
+Depends: ${misc:Depends}
+ , ${shlibs:Depends}
+Breaks: libllhttp9.1 (<< 6)
+Replaces: libllhttp9.1
+Description: HTTP messages parser library
+ A C HTTP messages parser generated from typescript
+ definitions, making it easier to maintain.
+ .
+ This package contains the shared library.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export PREFIX = /usr
export LIBDIR = /usr/lib/$(DEB_HOST_MULTIARCH)

#sonameVersion = $(shell echo $(DEB_VERSION_UPSTREAM) | cut -d '+' -f 1 | cut -d '.' -f -3)
sonameVersion = 9.3.0
sonameAlias = $(shell echo $(sonameVersion) | cut -d '.' -f -2)

export SONAME = libllhttp.so.$(sonameVersion)
export SONAMEALIAS = libllhttp.so.$(sonameAlias)

%:
	dh $@

override_dh_auto_clean-indep:
	- dh_auto_clean --buildsystem=nodejs

override_dh_auto_configure-indep:
	dh_auto_configure --buildsystem=nodejs

override_dh_auto_build-indep:
	dh_auto_build --buildsystem=nodejs
	RELEASE=$(sonameVersion) make release
	WASM_OPT=/usr/bin/wasm-opt WASM_CC=/usr/bin/clang WASM_CFLAGS="--sysroot=/usr -target wasm32-unknown-wasi" node debian/wasm.js

override_dh_auto_install-indep:
	dh_auto_install --buildsystem=nodejs

override_dh_auto_test-indep:
	dh_auto_test --buildsystem=nodejs


override_dh_auto_clean-arch:
	rm -rf release
	- dh_auto_clean --buildsystem=cmake --builddir=build-arch

execute_before_dh_auto_configure-arch:
	cp -rf /usr/src/llhttp release

override_dh_auto_configure-arch:
	dh_auto_configure --buildsystem=cmake --builddir=build-arch --sourcedir=release -- -DBUILD_STATIC_LIBS=ON

override_dh_auto_build-arch:
	dh_auto_build --buildsystem=cmake --builddir=build-arch --sourcedir=release

override_dh_auto_install-arch:
	dh_auto_install --buildsystem=cmake --builddir=build-arch --sourcedir=release
